<template>
  <div>
    <div style="margin: 3rem 0">
      <el-header style="margin-top:10rem">
        <ReturnButton  :offsetArrow="19" :spanTitle="3" title="Regresar" v-on:clickEvent="returnPage" style="margin:0 0 2rem 12rem"></ReturnButton>
        <!-- buscador -->
        <el-col :span="5" :offset="12">
          <app-search-filter v-model="textSearch" style="margin:1rem 0 1rem 96%"></app-search-filter>
        </el-col>
        <!-- titulo -->
        <el-col :offset="2" :span="20" class="bg-dark-gray text-white" style="padding:10px 20px">
          <span class="text-bold" style="font-size:20px">ALMACÉN:</span> <span class="text-white" style="font-size:20px"> {{titleContract}}</span>
        </el-col>
      </el-header>
      <el-col style="margin:2rem 0; padding:0 10rem">
        <p class="text-dark-gray-1" style="margin-bottom:2rem">TOTAL DE MATERIALES DEL CONTRATO: <span>{{totalMaterial}}</span></p>
        <p class="text-bold">Materiales Recibidos: <span>{{receivedMaterials}}</span></p>
        <p class="text-orange text-bold" style="margin:7px 0">Materiales Copiados: <span>{{copiedMat}}</span></p>
        <!-- <div class="bg-gray" style="margin:1rem 0; padding:10px 14px; width:20rem">
          <el-checkbox v-model="checked">Marcar todos los materiales como copiados</el-checkbox>
        </div> -->
      </el-col>
      <el-main style="margin-top:10rem; margin-left:10%; width:80%">
        <!-- {{searching}} -->
        <el-col v-for="(mat, index) in searching" :key="index">
          <el-card :body-style="{ padding: '0px'}" style="margin-bottom:3rem">
            <div :class="[ mat.hideForm?'bg-gray':'bg-white' ]" style="height:100%; min-height:7rem">
              <el-row style="margin:0rem; padding:1rem 2rem">
                <el-col :span="1"><i class="el-icon-caret-right" :class="[mat.hideForm? 'text-orange':'arrow-gray']" style="font-size:35px" @click="showFormCard(index)"></i></el-col>
                <el-col :span="21" style="padding:7px 21px 0">
                  <span class="text-bold" style="font-size:20px">{{mat.listTitle}}</span>
                  <!-- <span class="text-dark-gray-1" style="font-size:16px;  margin-left:1rem">(N° en el Contrato: {{contractPosition[index]}}/{{totalMaterial}}) {{textCounterAboutTypeOfContent(mat)}}</span> -->
                  <span class="text-dark-gray-1" style="font-size:16px;  margin-left:1rem">N° en el Contrato: ({{mat.contractPosition}})</span>
                  <span class="text-bold text-red" style="font-size:16px; margin-left:2rem">{{mat.showreplace}}</span>
                </el-col>
                <el-col :span="2"><img src="@/assets/images/borrador-rojo.svg" alt="borrador" @click="btnClean(index, searching, 'materialall')"></el-col>
                <el-col :span="24" style="padding:20px 58px 0">
                  <el-radio-group v-model="mat.statusStorage" v-if="mat.numChapters.length >0">
                    <el-radio :label="1">Pendiente</el-radio>
                    <el-radio :label="2">Incompleto</el-radio>
                    <el-radio :label="3">Completo</el-radio>
                  </el-radio-group>
                  <el-radio-group v-model="mat.statusStorage" v-else>
                    <el-radio :label="1">Pendiente</el-radio>
                    <el-radio :label="3">Copiado</el-radio>
                  </el-radio-group>
                </el-col>
              </el-row>
              <hr class="bg-gray" v-if="mat.hideForm">

               <!-- si tiene temporadas y capítulos-->
              <el-row class="bg-white" style="padding:2rem 5.7rem" v-show="mat.hideForm" v-if="mat.numChapters.length !== 0">
                <el-col :span="24" :offset="18">
                  <el-select v-model="mat.selectSeason" placeholder="Temporada" size="small" clearable>
                    <el-option
                      v-for="aSeason in mat.allSeason"
                      :key="aSeason.value"
                      :label="aSeason.label"
                      :value="aSeason.value">
                    </el-option>
                  </el-select>
                </el-col>
                <el-col v-for="(seas, ind) in mat.numChapters" :key="ind" >
                  <!--  v-if="seas.season===mat.selectSeason" -->
                  <el-col :span="24" style="margin:0.7rem 0">
                    <p class="text-bold" style="margin:0.5rem 0 2rem; font-size:17px">Temporada {{seas.season}}</p>
                    <p class="margin-between">Total de Capítulos: {{seas.chapters}}</p>
                    <span class="text-bold" style="margin:0.5rem 0">Capítulos Recibidos:{{receivedChapter(seas)}}</span>
                    <span class="text-orange text-bold" style="margin:0.5rem 0 0 3rem ">Capítulos Copiados:{{copiedChapter(seas)}}</span>
                    <hr style="margin:1.5rem 0">
                   
                    <el-col v-for="(cap, j) in seas.infoByChapter" v-if="cap.statusChapter == 2" :key="j" style="margin:1rem 0"> 
                        <el-row class="bg-gray" type="flex" align="middle"> 
                          <el-col :span="1"><i class="el-icon-caret-right" style="font-size:25px; color:#828282" @click="showCap(index, ind, j)"></i></el-col>
                          <el-col :span="6">Capítulo {{cap.chapter}}</el-col>
                          <el-col :span="10">
                            <el-radio-group v-model="cap.statusStorageChap" v-if="mat.numChapters">
                              <el-radio :label="1">Pendiente</el-radio><el-radio :label="2">Copiado</el-radio>
                            </el-radio-group>
                          </el-col>
                          <el-col :span="5">
                            <span class="text-bold text-red" style="font-size:14px; margin-left:2rem">{{cap.showreplace}}</span>
                          </el-col>
                          <el-col :span="2">
                            <img src="@/assets/images/borrador-rojo.svg" alt="borrador" style="width:32px" @click="btnClean(j, seas.infoByChapter, 'chapter')">
                          </el-col>
                        </el-row>
                      
                      <el-row style="margin-top:1rem" v-show="cap.hideChap">
                        <el-card :body-style="{ padding: '2rem 2rem'}" >
                          <el-row class="bg-white" style="font-size:14px">
                            <div class="bg-gray" style="margin:1rem 0 2rem; width:17rem; padding: 5px 7px"><span>COPIA DE BACK UP: </span>
                              <el-radio-group v-model="cap.copyBackup">
                                <el-radio :label="1">Sí</el-radio>
                                <el-radio :label="3">No</el-radio>
                              </el-radio-group>
                            </div>
                            <el-col :span="10">
                              <h4 class="text-orange" style="margin:0 0 1rem">ALMACENAMIENTO:</h4>
                              <el-col :span="24" style="margin:0.7rem 0">
                                <el-col :span="10" style="margin-top:0.5rem"><span>Fecha de Copiado:</span></el-col>
                                <el-col :span="10">
                                  <el-date-picker
                                    v-model="cap.dateOfCopy" type="date" size="small"
                                    placeholder="Seleccionar" format="dd/MM/yyyy" value-format="timestamp" class="vigencia-size">
                                  </el-date-picker>
                                </el-col>            
                              </el-col>
                              <el-col :span="24" style="margin:0.7rem 0">
                                <el-col :span="10" style="margin-top:0.5rem"><span>Almacenamiento:</span></el-col>
                                <!-- v-model="cap.storages" -->
                                <!-- :isDisabled="isChapterAble[j].isDisabled" -->
                                <el-col :span="14">
                                  <app-select  v-model="storagesSelect[index].storage" :filterArray="allstorages"  size="small" @changeValue="changeStoragesSelect({storages: storagesSelect, position: index})"></app-select>
                                  <!--  == cap.chapter ?  -->
                                </el-col>
                              </el-col>
                              <el-col :span="24" style="margin:0.7rem 0">
                                <el-col :span="10" style="margin-top:0.5rem"><span>Videoteca:</span></el-col>
                                <el-col :span="14">
                                  <app-select v-model="cap.videoteca" :filterArray="videotecaArray" size="small"></app-select>  
                                </el-col>    
                              </el-col>
                            </el-col>
                            <el-col :span="12" :offset="2" >
                              <h4 class="text-orange" style="margin:0 0 1rem">SOPORTE:</h4>
                              <div v-for="(supportChap, h) in cap.supportMaterial" :key="h">
                                <el-row style="margin:0.7rem 0">
                                  <el-col style="margin:0.7rem 0">
                                    <el-col ><span>Soporte de Almacén:</span></el-col>
                                    <el-col :span="14" style="margin:0.5rem 0">
                                      <app-select v-model="supportChap.typeStorage" :filterArray="allTypesStorage" size="small"></app-select>
                                    </el-col>
                                    <el-col :span="4" style="margin:0.5rem 0.5rem">
                                      <span>
                                        <i @click="addEl(cap.supportMaterial, h)" class="el-icon-circle-plus text-orange" style="font-size:25px"></i>
                                      </span>
                                      <span v-if="cap.supportMaterial.length > 1">
                                        <i @click="removeEl(cap.supportMaterial, h)" class="el-icon-remove text-gray" style="font-size:25px; margin-left: 4px"></i>
                                      </span>
                                    </el-col>
                                  </el-col>
                                  <el-col style="margin:0.7rem 0">
                                    <el-col :span="7" style="margin-top:0.5rem"><span>Código de Disco:</span></el-col>
                                    <!-- <p>{{cap.copyBackup}}</p> -->
                                    <el-col :span="12">
                                      <el-input v-model="supportChap.codeDisk" size="small" :disabled="chooseCopyBackup(cap.copyBackup)"></el-input>
                                    </el-col>          
                                  </el-col>
                                </el-row>
                              </div>
                            </el-col>                          
                            <el-col :offset="21" style="margin-top:3rem">
                              <el-button type="primary" size="small" @click="btnCopy(cap, j, seas.infoByChapter, 'chap')">COPIAR</el-button>
                            </el-col>
                          </el-row>
                        </el-card>

                        
                      </el-row>
                      
                    </el-col>
                  </el-col>
                </el-col>
              </el-row>

              <!-- no tiene temporadas -->                
              <el-row class="bg-white" style="padding:2rem 3rem" v-show="mat.hideForm" v-else>
                <div style="margin:1rem 0 2rem"><span>COPIA DE BACK UP: </span>
                  <el-radio-group v-model="mat.copyBackup">
                    <el-radio :label="1">Sí</el-radio>
                    <el-radio :label="3">No</el-radio>
                  </el-radio-group>
                </div>
                <el-col :span="9">
                  <h4 class="text-orange" style="margin:0 0 1rem">ALMACENAMIENTO:</h4>
                  <el-col :span="24" style="margin:0.7rem 0">
                    <el-col :span="10" style="margin-top:0.5rem"><span>Fecha de Copiado:</span></el-col>
                    <el-col :span="10">
                      <el-date-picker
                        v-model="mat.dateOfCopy" type="date" size="small"
                        placeholder="Seleccionar" format="dd/MM/yyyy" value-format="timestamp" class="fecha-material">
                      </el-date-picker>
                    </el-col>            
                  </el-col>
                  <el-col :span="24" style="margin:0.7rem 0">
                    <el-col :span="10" style="margin-top:0.5rem"><span>Almacenamiento:</span></el-col>
                    <el-col :span="13">
                      <!-- @change="changeStoragesSelect" -->
                      <app-select v-model="mat.storages" :filterArray="allstorages" size="small" ></app-select>
                    </el-col>
                  </el-col>
                  <el-col :span="24" style="margin:0.7rem 0">
                    <el-col :span="10" style="margin-top:0.5rem"><span>Videoteca:</span></el-col>
                    <el-col :span="13">
                      <app-select v-model="mat.videoteca" :filterArray="videotecaArray" size="small"></app-select>  
                    </el-col>    
                  </el-col>
                </el-col>
                <hr class="hr-vertical-grey">
                <el-col :span="13" :offset="2" >
                  <h4 class="text-orange" style="margin:0 0 1rem">SOPORTE:</h4>
                  <div v-for="(support, i) in mat.supportMaterial" :key="i">
                    <el-row style="margin:0.7rem 0">
                      <el-col style="margin:0.7rem 0">
                        <el-col :span="8" style="margin-top:0.5rem"><span>Soporte de Almacén:</span></el-col>
                        <el-col :span="8">
                          <app-select v-model="support.typeStorage" :filterArray="allTypesStorage" size="small"></app-select>
                        </el-col>
                        <el-col :span="4" style="margin-top: 4px; margin-left:12px">
                          <span>
                            <i @click="addEl(mat.supportMaterial, i)" class="el-icon-circle-plus text-orange" style="font-size:25px"></i>
                          </span>
                          <span v-if="mat.supportMaterial.length > 1">
                            <i @click="removeEl(mat.supportMaterial, i)" class="el-icon-remove text-gray" style="font-size:25px; margin-left: 3px"></i>
                          </span>
                        </el-col>
                      </el-col>
                      <el-col style="margin:0.7rem 0">
                        <el-col :span="8" style="margin-top:0.5rem"><span>Código de Disco:</span></el-col>
                        <el-col :span="11">
                          <el-input v-model="support.codeDisk" size="small" :disabled="chooseCopyBackup(mat.copyBackup)"></el-input>
                        </el-col>          
                      </el-col>
                    </el-row>
                  </div>
                </el-col>
                <el-col :offset="21">
                  <el-button type="primary" size="small" @click="btnCopy(mat, index, searching, 'nochap')">COPIAR</el-button>
                </el-col>
              </el-row>
              <!-- Modal botón copiar -->
              <AppModal :show-dialog.sync="modalCopy" v-if="modalCopy" nameClass="dialog-orange"  :rutImg="require(`../../../assets/images/suspicious.svg`)" sizeImg="80px"  textBold="¡Un momento!" 
                :parrafo="paragraph"
                classBtn1="border-orange" typeBtn1="primary" btn1="SÍ, COPIAR" btn2="CANCELAR"  @btnEvent="saveCopy()" v-on:eventBtn="modalCopy = false">
              </AppModal>
              <!-- modal borrar -->
              <AppModal :show-dialog.sync="modalClean" v-if="modalClean" nameClass="dialog-red"  :rutImg="require(`../../../assets/images/alerta.svg`)" sizeImg="80px"  textBold="¡Un momento!" 
                parrafo="¿Seguro de que quieres borrar la información ingresada?"
                classBtn1="border-red" typeBtn1="danger" btn1="SÍ, BORRAR" btn2="CANCELAR"  @btnEvent="clean()" v-on:eventBtn="modalClean = false">
              </AppModal>
            </div>
          </el-card>
        </el-col>   
      </el-main>
      <div style="margin-left:8%; width:84%">
        <el-row type="flex" justify="end">
          <el-col :span="6" >
            <el-button @click="cancel" size="small" style="margin:0 2rem 0 0" plain> CANCELAR </el-button>
            <el-button type="primary" @click="register" size="small"> REGISTRAR </el-button>
          </el-col>
        </el-row>
      </div>   
      <!-- Modal botón ingresar-->
      <AppModalSuccess :show-dialog.sync="registerModal" v-if="registerModal" 
        :parrafo="'Se guardo la información de la recepción de los materiales'"
        btn1="ACEPTAR"  @btnEvent="returnPage" v-on:btnEvent = "registerModal = false">
      </AppModalSuccess>
    </div>
  </div>
</template>
<style>
  .vigencia-size {
    width: 189px !important;
}
  .fecha-material {
    width: 12rem !important; 
}
</style>

<script>
import SearchFilter from '@/components/searchFilter.vue'
import ReturnButton from '@/components/ReturnButton.vue'
import { modifyText } from '@/utils/modifyText.js'

import Select from '@/components/AppSelect.vue'
import AppModal from '@/components/AppModal.vue'
import AppModalSuccess from '@/components/AppModalSuccess.vue'
import {HTTP} from '@/main.js'
import { convertDate } from '@/utils/calculateTime.js'

export default {
  components: {
    ReturnButton,
    'app-search-filter': SearchFilter,
    'app-select': Select,
    AppModal,
    AppModalSuccess
  },

  data () {
    return {
      checked: false,
      idStorageMat: this.$store.state.idStorageMat,
      // idStorageMat: this.$localStorage.get('idStorageMat'),
      // materialsStorage: JSON.parse(this.$localStorage.get("materialsReceived")),
      materialsStorage: [],
      modalCopy: false,
      registerModal: false,
      storageSupport: this.$store.state.contracts, // array con todos los contratos
      textSearch: '', // buscador
      titleContract: '', // Título de Contrato
      totalMaterial: 0,
      indexClean: '',// boton borrar
      itemClean: '', // boton borrar
      arrClean: [], // array borrar
      modalClean: false, // modal borrar
      item: {},
      index: '',
      array: [],
      typeCard: '',
      allstorages:[
        {value: 'Master', label: 'Master'},
        {value: 'Producción Nacional', label: 'Producción Nacional'},
      ],
      videotecaArray:[
        {value: 'Santa Beatriz', label: 'Santa Beatriz'},
        {value: 'Pachacamac', label: 'Pachacamac'},
      ],
      allTypesStorage: [], // array de los tipos de soporte
      onlyChapterReceived: [],
      allMaterials: [],
      arrPositionMaterial: [],
      nameTypeStorage: '',
      statusContractStorage: '',
      // getContract: JSON.parse(this.$localStorage.get("contractReceived")),
      getContract: this.$store.state.contractReceived,
      isChapterAble: [],
      storagesSelect: [],
      contract: this.$store.state.contractForStorageCanned,
    }
  },
  computed:{
    searching () {//  buscador
      let filtered = this.materialsStorage
      return filtered.filter(m => modifyText(m.listTitle).indexOf(modifyText(this.textSearch)) > -1)
    },
    receivedMaterials (){
      let received = []
      this.materialsStorage.map((el) => {
        if (el.statusMaterial === 3 || el.statusMaterial === 2){
          received.push(el.statusMaterial)
        }
      })
      return received.length
    },
    contractPosition (){
      for(var i=0; i<this.allMaterials.length; i++){
        for(var n=0; n<this.materialsStorage.length; n++){
          if(this.materialsStorage[n]._id == this.allMaterials[i]._id ){
            this.arrPositionMaterial.push(i+1)
          }
        }
      }

      return this.arrPositionMaterial
    },
    copiedMat (){
      let copied = []
      this.materialsStorage.map((el)=>{
        if(el.statusStorage === 3){
          copied.push(el.statusStorage)
        }
      })
      return copied.length
    },
  },
  created () {
    this.getMaterialsRecieved()
    this.receivedChapter()
    this.copiedChapter()
    this.getTables()
    this.storagesSelect = this.storagesSelectData()
  },
  beforeDestroy() {
    this.$store.dispatch('getData', "contracts")
    this.$store.dispatch("getData", "materials")
  },
  methods: {
    getMaterialsRecieved () {
      let materials = this.getContract.admittedMaterials
      this.allMaterials  = this.getContract.admittedMaterials
      this.totalMaterial = this.getContract.admittedMaterials.length
      materials = materials.filter( m => m.statusMaterial ===3 || m.statusMaterial ===2)
      this.materialsStorage = materials
    },
    getTables () { // tabla de tipos de soporte
      HTTP.get(`tables/tableName/typeOfSupport`)
        .then(res => {
          let support = res.data
          let supportTypes = support.table[0].types

          let array = []
          supportTypes.map((el) => {
            array.push({value: el, label: el})
          })
          this.allTypesStorage = array  
        })
        .catch(err => console.log(err))

    },
    receivedChapter (seas) { // capitulos recibidos
      if(seas){
      let arrayReceivedMat = []
        seas.infoByChapter.map((el)=>{
          if(el.statusChapter === 2){
            arrayReceivedMat.push(el.statusChapter)
          }
        })
        return arrayReceivedMat.length
      }
    },
    copiedChapter (seas){ // capitulos copiados
      if (seas){
      let arrCopiedMat = []
        seas.infoByChapter.map((el)=>{
          if(el.statusStorageChap === 2){
            arrCopiedMat.push(el.statusStorageChap)
          }
        })
        return arrCopiedMat.length
      }
    },
    addEl (item, index){ // boton añadir nuevo soporte
      item.map((el, indx, arr) => {
        if (indx == index) {
          arr.splice(indx + 1, 0, {codeDisk: '', typeStorage: ''})
        }
      })
    },
    removeEl (arr, index) { // boton eliminar soporte
      arr.splice(index, 1)
    },
    returnPage () {
      this.$router.push({ name: 'storageCanned' })
    },
    showFormCard (index){
      // toogle button
      let updateMat= this.materialsStorage[index]    
      updateMat.hideForm = !updateMat.hideForm     
    },
    btnClean (index, arr, itemType){
     this.modalClean = true
     this.indexClean = index
     this.arrClean = arr
     this.itemClean = itemType
    },
    clean (){// boton borrador
      let updateMat = this.arrClean[ this.indexClean]

      if(this.itemClean === 'materialall'){ // boton donde trae el material
        if(updateMat.numChapters.length !== 0){
          // ingresando a cada capitulo
          updateMat.numChapters.map((el)=>{
            // ingresando a cada capitulo
            el.infoByChapter.map((chap)=>{
              chap.statusStorageChap= 1
              chap.copyBackup = ''
              chap.dateOfCopy = ''
              chap.storages = ''
              chap.videoteca= ''
              chap.supportMaterial = [{codeDisk: '', typeStorage: ''}]
            })
          })
        }
        else{
          this.arrClean[this.indexClean].statusStorage= 1
          this.arrClean[this.indexClean].copyBackup= ''
          this.arrClean[this.indexClean].dateOfCopy= ''
          this.arrClean[this.indexClean].storages= ''
          this.arrClean[this.indexClean].videoteca= ''
          this.arrClean[this.indexClean].supportMaterial = [{codeDisk: '', typeStorage: ''}]

        }
      }else{ // boton donde trae capitulo
        console.log('capitulo')
        this.arrClean[this.indexClean].statusStorageChap= 1
        this.arrClean[this.indexClean].copyBackup= ''
        this.arrClean[this.indexClean].dateOfCopy= ''
        this.arrClean[this.indexClean].storages= ''
        this.arrClean[this.indexClean].videoteca= ''
        this.arrClean[this.indexClean].supportMaterial = [{codeDisk: '', typeStorage: ''}]
      }
      this.modalClean = false
    },

    btnCopy (item, index, array, typeCard){
      // boton copiar
      (typeCard === 'nochap')? this.paragraph ='¿Quieres copiar la información en todos los materiales?':this.paragraph = '¿Quieres copiar la información en todos los capítulos?'
      this.modalCopy = true
      this.item = item
      this.index = index
      this.typeCard = typeCard

      if(typeCard === 'nochap'){
        this.array = array
      } else {
        this.onlyChapterReceived = []
        array.map(el => {
          if(el.statusChapter == 2){
            this.onlyChapterReceived.push(el)
          }
        })
      }
      
    },
    items (el){
      el.copyBackup = this.item.copyBackup
      el.dateOfCopy = this.item.dateOfCopy
      el.storages = this.item.storages
      el.videoteca  = this.item.videoteca
     
      el.supportMaterial = []
      this.item.supportMaterial.map((elem)=>{
        el.supportMaterial.push({codeDisk: elem.codeDisk, typeStorage:elem.typeStorage})
      })
    },
    saveCopy (){
      if(this.typeCard === 'nochap'){
        this.array.map((el, i)=>{
            if(i > this.index){
              this.items(el)
              el.statusStorage = this.item.statusStorage
            }
          
        })
      }else{
        this.onlyChapterReceived.map((el, i)=>{
          if(i > this.index){
            this.items(el)
            el.statusStorageChap = this.item.statusStorageChap
          }
        })
      }
      this.modalCopy = false
    },
    showCap (index, ind, j){

      let updateMat= this.materialsStorage[index]      // material actual
      let updateSeason = updateMat.numChapters[ind]   // temporada actual
     
      let updateChap = updateSeason.infoByChapter[j]   // capitulo actual
      updateChap.hideChap = !updateChap.hideChap
    },
    cancel () {
      this.$router.push({ name: 'storageCanned' })
    },
    register () {
      this.saveMaterial()

      let statusContractStorage = ''
      let materialsStorage = this.materialsStorage // materiales del contrato
      let totalMaterial = materialsStorage.length //total de materiales      
      let arrayMatStatus3 = []
      let arrayMatStatus2 = []

      for(var i=0; i<this.allMaterials.length; i++) {
        for(var n=0; n<materialsStorage.length; n++){
          if(materialsStorage[n]._id == this.allMaterials[i]._id ){
            this.allMaterials[i] = materialsStorage[n]
          }
        }
      }

      materialsStorage.map((el)=>{
        if(el.statusStorage === 3){
          arrayMatStatus3.push(3)
        } 
        if(el.statusStorage === 2){
          arrayMatStatus2.push(2)
        }
      })
      
      if(arrayMatStatus3.length === totalMaterial){
        statusContractStorage = 'COMPLETO'
      } else if (arrayMatStatus3.length === 0 && arrayMatStatus2.length === 0) {
        statusContractStorage = 'PENDIENTE'
      } else {
        statusContractStorage = 'INCOMPLETO'
      }

      let nameTypeStorage
      (statusContractStorage === 'COMPLETO')? nameTypeStorage = 'success': (statusContractStorage === 'INCOMPLETO')? nameTypeStorage = 'danger':nameTypeStorage = 'info'
      
      this.nameTypeStorage = nameTypeStorage
      this.statusContractStorage = statusContractStorage

      this.saveContract()
    },
    saveMaterial () {
      let materialsStorage = this.materialsStorage
      for(let i = 0; i < this.materialsStorage.length; i++) {
        let numb = this.materialsStorage[i].numChapters
        let existNumberChapters = numb.length > 0 ?  numb.chapters : 0
        
        let existRepositionInInfosupport
        if(this.materialsStorage[i].infoSupport) {
          existRepositionInInfosupport =  this.materialsStorage[i].infoSupport.length !== 0 ? this.materialsStorage[i].infoSupport.reposicion : []
        } else {
          existRepositionInInfosupport = []
        }
        
        let info = {
          "arrivalDate": this.materialsStorage[i].arrivalDate || '',
          "guideNumber": this.materialsStorage[i].guideNumber || '',
          "shippingMode": this.materialsStorage[i].shippingMode || '',
          "copyBackup": this.materialsStorage[i].copyBackup || '',
          "dateOfCopy": this.materialsStorage[i].dateOfCopy || '',
          "storages": this.materialsStorage[i].storages || '',
          "videoteca": this.materialsStorage[i].videoteca || '',
          "replacement": this.materialsStorage[i].replacement || false,
          "showreplace": this.materialsStorage[i].showreplace || '',
          "supportMaterial": this.materialsStorage[i].supportMaterial || [],
          "replacementStorage": this.materialsStorage[i].replacementStorage || false,
          "arrivalSupport": this.materialsStorage[i].arrivalSupport || '',
          "reposicion": existRepositionInInfosupport || [],
          "statusMaterial": this.materialsStorage[i].statusMaterial || '',
          "statusStorage": this.materialsStorage[i].statusStorage || ''
        }

        this.materialsStorage[i].infoSupport = info

        
        if (existNumberChapters == 0 ) {
          HTTP.patch(`materials/update/${materialsStorage[i]._id}`, [
            {propName: "infoSupport", value: info}
          ])
          .then(res => {
            let payload = {
              type: 'materials',
              typeFilter: 'materialType',
              typeOfContent: '',
              typeMaterial: 'Enlatado',
              typeFilter2: 'providerName'
            }

            if( this.materialsStorage[i].typeOfContent == 'LARGOMETRAJES' ) {
              payload.typeOfContent = 'Largometrajes'
            }
            else if (this.materialsStorage[i].typeOfContent == 'MINI SERIE') {
              payload.typeOfContent = 'Miniseries'
            }
            else if (this.materialsStorage[i].typeOfContent == 'ESPECIALES') {
              payload.typeOfContent = 'Especial'
            }
            else {
              payload.typeOfContent = this.materialsStorage[i].typeOfContent
            }
    
            this.$store.dispatch('getDataFilters', payload)  

          })
          .catch(err => console.log(err))
        }
      }
    },
    saveContract() {
      this.getContract.admittedMaterials.map((e, i) => {
        if(e.numChapters.length > 0) {
          let first = e.numChapters[0].infoByChapter[0].storages
          e.numChapters[0].infoByChapter.map((el, index) => {
            if(el.statusStorageChap == 2) {
              this.getContract.admittedMaterials[i].numChapters[0].infoByChapter[index].storages = first
            }
          })
        }
      })
      HTTP.patch('contracts/' + this.idStorageMat,
        [
          { propName: "nameTypeStorage", value: this.nameTypeStorage},
          { propName: "statusContractStorage", value: this.statusContractStorage },
          { propName: "admittedMaterials", value: this.getContract.admittedMaterials },
        ]
      )
      .then(res => {
        this.registerModal = true
      })
      .catch(err => console.log(err))     
    },
    isDisabled() {
      if(this.searching && this.searching[0] && this.searching[0].numChapters && this.searching[0].numChapters.length > 0) {
        const value = this.searching[0].numChapters[0].infoByChapter.map((e, i) => ({
          chapter: e.chapter,
          isDisabled: i == 0 ? false : true
        }))
        return value
      } else {
        return [ {isDisabled: false}]
      }
    },
    changeStoragesSelect(val) {
      const position = val.position
      let dataChange = this.materialsStorage[position].numChapters[0].infoByChapter.map((e) => {
        const {storages, ...rest} = e
        return {
          storages: val.storages[position].storage,
          ...rest
        }
      })
      this.materialsStorage[position].numChapters[0].infoByChapter = dataChange
    },
    storagesSelectData() {
      const transformStorages = this.materialsStorage.map((e) => {
        if(e.numChapters.length >= 1) {
          const {infoByChapter} = e.numChapters[0]
          return {storage: infoByChapter[0].storages}
        } else {
          return {storage: e.infoSupport.storages}
        }
      })
      // console.log(transformStorages, 'transformStorages')
      return transformStorages
    },
    chooseCopyBackup(val) {
      if(!val || val === '') {
        return true
      } else {
        return false
      }
    }
  },
}
</script>
